<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8"/>
    <title>Gitlab Issues</title>
    <link rel="stylesheet" type="text/css" href="css/bootstrap.min.css">
</head>
<body>
    <div class="container-fluid">
        <h1>Issue Management</h1>
        <div class="form-group row">
            <div class="col">
                <select id="filter-group" class="form-control" onchange="getProjects();getMembers()">
                    <option value="">Select Group</option>
                </select>
            </div>
            <div class="col">
                <select id="filter-project" class="form-control" onchange="getIssues();getMembers();getMilestones()">
                    <option value="">Select Project</option>
                </select>
            </div>
            <div class="col">
                <select id="filter-state" class="form-control" onchange="getIssues()">
                    <option value="">Semua State</option>
                    <option value="opened" selected>Opened</option>
                    <option value="closed">Closed</option>
                </select>
            </div>
            <div class="col">
                <select id="filter-member" class="form-control" onchange="getIssues()">
                    <option value="">Select Member</option>
                </select>
            </div>
            <div class="col">
                <select id="filter-milestone" class="form-control" onchange="getIssues()">
                    <option value="">Select Milestone</option>
                </select>
            </div>
            <div class="col">
                <select id="filter-page" class="form-control" onchange="getIssues();">
                    <option value="1">1</option>
                </select>
            </div>
        </div>
        <div class="form-group">
            <div class="form-inline">
                <div class="form-group">
                    <select id="member" class="form-control">
                        <option value="">Select Member</option>
                    </select>
                </div>
                <div class="form-group mx-sm-1">
                    <button class="btn btn-primary" onclick="assignIssues()">Assign</button>
                </div>
                <div class="form-group">
                    <select id="milestone" class="form-control">
                        <option value="">Select Milestone</option>
                    </select>
                </div>
                <div class="form-group mx-sm-1">
                    <button class="btn btn-primary" onclick="milestoneIssues()">Set Milestone</button>
                </div>
                <div class="form-group">
                    <button class="btn btn-danger" onclick="deleteIssues()">Delete</button>
                </div>
            </div>
        </div>
        <div class="form-group">
            <table id="issues" class="table table-bordered table-sm">
                <thead>
                    <th width="1"><input type="checkbox" id="check_all_issues"></th>
                    <th width="1">ID</th>
                    <th>Title</th>
                    <th>Assignee</th>
                    <th>Author</th>
                    <th>Milestone</th>
                    <th>State</th>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>
    <script type="text/javascript" src="jquery-3.2.1.min.js"></script>
    <script type="text/javascript" src="js/bootstrap.min.js"></script>
    <script type="text/javascript" src="git.config.js"></script>
    <script type="text/javascript">
        $(function() {
            getGroups();
            $('#check_all_issues').change(function() {
                $('[name*="checkbox_issues"]').prop('checked', $(this).prop('checked'));
            });
        });
        function getGroups() {
            $.ajax({
                url: git.URL+'/groups?private_token='+git.PRIVATE_TOKEN,
                success: function(response) {
                    let html = '<option value="">Select Group</option>';
                    $.each(response, function(key, row) {
                        html+= '<option value="'+row.id+'">'+row.name+'</option>';
                    });
                    $('#filter-group').html(html);
                }
            });
        }

        function getProjects() {
            let group = $('#filter-group').val();
            $.ajax({
                url: git.URL+'/groups/'+group+'/projects?private_token='+git.PRIVATE_TOKEN,
                success: function(response) {
                    let html = '<option value="">Select Project</option>';
                    $.each(response, function(key, row) {
                        html+= '<option value="'+row.id+'">'+row.name+'</option>';
                    });
                    $('#filter-project').html(html);
                }
            });
        }

        function getMilestones() {
            let project = $('#filter-project').val();
            $.ajax({
                url: git.URL+'/projects/'+project+'/milestones?private_token='+git.PRIVATE_TOKEN,
                success: function(response) {
                    let html = '<option value="">Select Milestone</option>';
                    $.each(response, function(key, row) {
                        html+= '<option value="'+row.id+'">'+row.title+'</option>';
                    });
                    $('#filter-milestone').html(html);
                    $('#milestone').html(html);
                }
            });
        }

        function getMembers() {
            let group = $('#filter-group').val();
            $('#filter-member').html('<option value="">Select Member</option>');
            $('#member').html('<option value="">Select Member</option>');
            $.ajax({
                url: git.URL+'/groups/'+group+'/members?private_token='+git.PRIVATE_TOKEN,
                success: function(response) {
                    $.each(response, function(key, row) {
                        let html = '<option value="'+row.id+'">'+row.name+'</option>';
                        $('#filter-member').append(html);
                        $('#member').append(html);
                    });
                }
            });
            let project = $('#filter-project').val();
            if (project) {
                $.ajax({
                    url: git.URL+'/projects/'+project+'/members?private_token='+git.PRIVATE_TOKEN,
                    success: function(response) {
                        $.each(response, function(key, row) {
                            let html = '<option value="'+row.id+'">'+row.name+'</option>';
                            $('#filter-member').append(html);
                            $('#member').append(html);
                        });
                    }
                });
            }
        }

        function getIssues() {
            var filters = '';
            let project = $('#filter-project').val();
            let member = $('#filter-member').val();
            if (member) {
                filters += '&assignee_id='+member;
            }
            let milestone = $('#filter-milestone').val();
            if (milestone) {
                filters += '&milestone='+$('#filter-milestone option:selected').text();
            }
            let state = $('#filter-state').val();
            if (state) {
                filters += '&state='+state;
            }
            let page = $('#filter-page').val();
            $.ajax({
                url: git.URL+'/projects/'+project+'/issues?private_token='+git.PRIVATE_TOKEN+'&page='+page+'&per_page=100'+filters,
                success: function(response, textStatus, request) {
                    let html = '';
                    $.each(response, function(key, row) {
                        html += '<tr>';
                            html += '<td><input type="checkbox" value="'+row.iid+'" name="checkbox_issues['+row.iid+']"></td>';
                            html += '<td>'+row.iid+'</td>';
                            html += '<td>'+row.title+'</td>';
                            html += '<td>'+((row.assignee) ? row.assignee.name : '')+'</td>';
                            html += '<td>'+row.author.name+'</td>';
                            html += '<td>'+((row.milestone) ? row.milestone.title : '')+'</td>';
                            html += '<td>'+row.state+'</td>';
                        html += '</tr>';
                    });
                    $('#issues tbody').html(html);
                    let pages = request.getResponseHeader('X-Total-Pages');
                    let htmlPage = '';
                    for (let i = 1; i<=pages; i++) {
                        htmlPage += '<option value="'+i+'" '+((i==page) ? 'selected' : '')+'>'+i+'</option>';
                    }
                    $('#filter-page').html(htmlPage);
                }
            });
        }

        function deleteIssues() {
            let conf = confirm('Are you sure?');
            if (!conf) {
                return false;
            }
            let project = $('#filter-project').val();
            let total = $('[name*="checkbox_issues"]:checked').length;
            let deleted = 0;
            $('[name*="checkbox_issues"]:checked').each(function(key, elem) {
                $.ajax({
                    url: git.URL+'/projects/'+project+'/issues/'+$(elem).val()+'?private_token='+git.PRIVATE_TOKEN,
                    type: 'delete',
                    success: function(response) {
                        deleted++;
                        if (total == deleted) {
                            alert('Completed');
                            getIssues();
                        }
                    }
                })
            });
        }

        function assignIssues() {
            let conf = confirm('Are you sure?');
            if (!conf) {
                return false;
            }
            let project = $('#filter-project').val();
            let member = $('#member').val();
            let total = $('[name*="checkbox_issues"]:checked').length;
            let assigned = 0;
            $('[name*="checkbox_issues"]:checked').each(function(key, elem) {
                $.ajax({
                    url: git.URL+'/projects/'+project+'/issues/'+$(elem).val()+'?private_token='+git.PRIVATE_TOKEN,
                    type: 'put',
                    data: {
                        assignee_ids:[member]
                    },
                    success: function(response) {
                        assigned++;
                        if (total == assigned) {
                            alert('Completed');
                            getIssues();
                        }
                    }
                })
            });
        }

        function milestoneIssues() {
            let conf = confirm('Are you sure?');
            if (!conf) {
                return false;
            }
            let project = $('#filter-project').val();
            let milestone = $('#milestone').val();
            let total = $('[name*="checkbox_issues"]:checked').length;
            let seted = 0;
            $('[name*="checkbox_issues"]:checked').each(function(key, elem) {
                $.ajax({
                    url: git.URL+'/projects/'+project+'/issues/'+$(elem).val()+'?private_token='+git.PRIVATE_TOKEN,
                    type: 'put',
                    data: {
                        milestone_id:milestone
                    },
                    success: function(response) {
                        seted++;
                        if (total == seted) {
                            alert('Completed');
                            getIssues();
                        }
                    }
                })
            });
        }
    </script>
</body>
</html>